"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
var arraydiff_1 = require("./utils/arraydiff");
exports.messages = {
    'array.typeof': function (name) { return name + " must be a valid array"; },
    'array.min': function (name, args) {
        return name + " must contains at least " + args.min + " items";
    },
    'array.max': function (name, args) {
        return name + " must contains at most " + args.max + " items";
    },
    'array.in': function (name, args) {
        return name + " must only contains these keys [" + args.in + "]";
    },
    'array.not': function (name) { return name + " contains forbidden value"; },
    'array.unique': function (name) { return name + " can not contains duplicated value"; },
    'array.oneOf': function (name) { return name + " contains forbidden items"; },
    'array.itemInvalid': function (name) {
        return name + " does not match any of the allowed types";
    },
};
/**
 * Array class
 */
var TypeArray = /** @class */ (function (_super) {
    __extends(TypeArray, _super);
    /**
     * Constructor
     */
    function TypeArray() {
        var _this = _super.call(this) || this;
        _this.name = 'array';
        _this.typeof();
        return _this;
    }
    /**
     * Test to validate the type of the value
     *
     * @return {this}
     */
    TypeArray.prototype.typeof = function () {
        this.test('typeof', function (str) {
            return Array.isArray(str);
        });
        return this;
    };
    /**
     * Force an array to contains at least a number of items equal to the value passed.
     *
     * @param  {number} min
     * @return {this}
     */
    TypeArray.prototype.min = function (min) {
        this.test('min', function (str) {
            return str.length >= min;
        }, { min: min });
        return this;
    };
    /**
     * Force an array to contains at most a number of items equal to the value passed.
     *
     * @param  {number} max
     * @return {this}
     */
    TypeArray.prototype.max = function (max) {
        this.test('max', function (str) {
            return str.length <= max;
        }, { max: max });
        return this;
    };
    TypeArray.prototype.in = function () {
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        var only = array;
        // handle someone passing literal array instead of multiple args
        if (array.length === 1 && Array.isArray(array[0])) {
            only = array[0];
        }
        this.test('in', function (str) {
            return arraydiff_1.default(str, only).length === 0;
        }, { in: only });
        return this;
    };
    TypeArray.prototype.not = function () {
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        var only = array;
        // handle someone passing literal array instead of multiple args
        if (array.length === 1 && Array.isArray(array[0])) {
            only = array[0];
        }
        this.test('not', function (str) {
            return arraydiff_1.default(only, str).length === only.length;
        }, { not: only });
        return this;
    };
    /**
     * Force an array to only have each item once
     *
     * @return {this}
     */
    TypeArray.prototype.unique = function () {
        this.test('unique', function (str) {
            var a = new Set(str);
            return a.size === str.length;
        });
        return this;
    };
    /**
     * Force all array's items to match one of the template
     *
     * @param  {...Validator} templates
     * @return {this}
     */
    TypeArray.prototype.oneOf = function () {
        var _this = this;
        var templates = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            templates[_i] = arguments[_i];
        }
        this.test('oneOf', function (array) { return __awaiter(_this, void 0, void 0, function () {
            var errors;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        errors = [];
                        return [4 /*yield*/, Promise.all(array.map(function (value, index) { return __awaiter(_this, void 0, void 0, function () {
                                var error, label, i, test_1;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            error = undefined;
                                            label = 'item';
                                            i = 0;
                                            _a.label = 1;
                                        case 1:
                                            if (!(i < templates.length)) return [3 /*break*/, 4];
                                            return [4 /*yield*/, templates[i].required().validate(value)];
                                        case 2:
                                            test_1 = _a.sent();
                                            if (test_1) {
                                                error = { label: label, test: test_1, position: index };
                                            }
                                            else {
                                                // early break if one template matched (returned no error)
                                                return [2 /*return*/];
                                            }
                                            _a.label = 3;
                                        case 3:
                                            i++;
                                            return [3 /*break*/, 1];
                                        case 4:
                                            // Help typescript understand we have error here
                                            if (!error) {
                                                return [2 /*return*/];
                                            }
                                            // if multiples templates, return a generic message
                                            if (templates.length > 1) {
                                                error = {
                                                    label: label,
                                                    test: this.createTestResult(this.createTest({
                                                        type: 'array.itemInvalid',
                                                    }), false),
                                                    position: index,
                                                };
                                                errors.push(error);
                                            }
                                            else {
                                                errors.push(error);
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, {
                                valid: errors.length <= 0,
                                error: 'not_matching',
                                errors: errors,
                            }];
                }
            });
        }); }, { templates: templates });
        return this;
    };
    return TypeArray;
}(base_1.default));
exports.TypeArray = TypeArray;
var def = {
    Class: TypeArray,
    messages: exports.messages,
};
exports.default = def;
