"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var createTest_1 = require("./utils/createTest");
/**
 * All type inherit this Class
 */
var TypeBase = /** @class */ (function () {
    /**
     * Constructor
     *
     * @param  {Altheia} inst
     */
    function TypeBase(inst) {
        this.createTest = createTest_1.createTest;
        this.createTestResult = createTest_1.createTestResult;
        this.inst = inst || require('./index');
        this.tests = [];
        this._required = false;
        this._needCast = false;
    }
    /**
     * Clone this class
     *
     * @return {TypeBase}
     */
    TypeBase.prototype.clone = function () {
        var clone = Object.assign(Object.create(this), this);
        // Quick deep clone
        clone.tests = this.tests.slice(0);
        return clone;
    };
    /**
     * Add a test
     *
     * @param  {string} name
     * @param  {function} func
     * @param  {Object} args
     * @return {undefined}
     */
    TypeBase.prototype.test = function (name, func, args) {
        var _this = this;
        if (args === void 0) { args = {}; }
        this.tests.push(function () {
            return _this.createTest({
                type: _this.name + "." + name,
                func: func,
                args: args,
            });
        });
    };
    /**
     * Validate a value based on all tests added
     * @param  {mixed}   toTest
     * @param  {Function} callback
     * @return {object}
     */
    TypeBase.prototype.validate = function (toTest, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var returnOrCallback, presence, i, test_1, internalResult, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        returnOrCallback = function (result, callback) {
                            if (callback) {
                                callback(result);
                            }
                            return result;
                        };
                        presence = this.presence(toTest);
                        if (presence === false) {
                            if (this._required === false) {
                                return [2 /*return*/, returnOrCallback(false, callback)];
                            }
                            return [2 /*return*/, returnOrCallback(this.createTestResult(this.createTest({
                                    type: 'required',
                                }), false), callback)];
                        }
                        if (!this._needCast) return [3 /*break*/, 2];
                        return [4 /*yield*/, this._cast(toTest)];
                    case 1:
                        // @ts-ignore
                        toTest = _b.sent();
                        _b.label = 2;
                    case 2:
                        i = 0;
                        _b.label = 3;
                    case 3:
                        if (!(i < this.tests.length)) return [3 /*break*/, 6];
                        test_1 = this.tests[i]();
                        internalResult = void 0;
                        _a = this.testToTestResult;
                        return [4 /*yield*/, test_1.func(toTest)];
                    case 4:
                        internalResult = _a.apply(this, [_b.sent()]);
                        // Let test override current test type/arguments
                        // Helps when you encapsulate test inside other test and want a transparent error
                        //   e.g: `if()`
                        if (internalResult.overrideWith) {
                            test_1.type = internalResult.overrideWith.type;
                            test_1.args = internalResult.overrideWith.args;
                        }
                        if (typeof internalResult.error === 'undefined' ||
                            typeof internalResult.valid === 'undefined') {
                            throw new Error('test() should return a boolean or an object { valid: boolean, error: string }');
                        }
                        // Do not go deeper in test
                        if (!internalResult.valid) {
                            return [2 /*return*/, returnOrCallback(this.createTestResult(test_1, internalResult.valid, internalResult), callback)];
                        }
                        _b.label = 5;
                    case 5:
                        i++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/, returnOrCallback(false, callback)];
                }
            });
        });
    };
    /**
     * Force the value to be non-null
     *
     * @return {this}
     */
    TypeBase.prototype.required = function () {
        this._required = true;
        return this;
    };
    /**
     * Force the value to be casted before any check
     *
     * @return {this}
     */
    TypeBase.prototype.cast = function () {
        this._needCast = true;
        return this;
    };
    /**
     * Custom validator
     *
     * @param  {string}   name
     * @param  {Function} callback
     * @param  {Function}   message
     * @return {this}
     */
    TypeBase.prototype.custom = function (name, callback) {
        var _this = this;
        this.test("custom." + name, function (value) { return __awaiter(_this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, callback(value)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_1 = _a.sent();
                        return [2 /*return*/, false];
                    case 3: return [2 /*return*/];
                }
            });
        }); }, {});
        return this;
    };
    /**
     * Presence validation
     *
     * @param  {mixed} toTest
     * @return {boolean}
     */
    TypeBase.prototype.presence = function (toTest) {
        if (toTest === null ||
            typeof toTest === 'undefined' ||
            toTest === undefined) {
            return false;
        }
        if (typeof toTest === 'string' && toTest.length <= 0) {
            // If the flag is passed to true
            // we consider the string valid and can be deeply tested,
            // this will trigger the noEmpty() test
            if (this._noEmpty) {
                return true;
            }
            return false;
        }
        return true;
    };
    /**
     * If validation
     *
     * @param  {function} options.test
     * @param  {function} options.then
     * @param  {function} options.otherwise
     * @return {this}
     */
    TypeBase.prototype.if = function (_a) {
        var _this = this;
        var test = _a.test, then = _a.then, otherwise = _a.otherwise;
        this.test('if', function (str) { return __awaiter(_this, void 0, void 0, function () {
            var clone, hasError, temp_1, temp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        clone = this.clone();
                        clone.tests = [];
                        return [4 /*yield*/, test(clone).validate(str)];
                    case 1:
                        hasError = _a.sent();
                        if (!!hasError) return [3 /*break*/, 3];
                        clone.tests = [];
                        return [4 /*yield*/, then(clone).validate(str)];
                    case 2:
                        temp_1 = _a.sent();
                        return [2 /*return*/, temp_1 && temp_1.result
                                ? __assign({}, temp_1.result, { overrideWith: temp_1 }) : true];
                    case 3:
                        clone.tests = [];
                        return [4 /*yield*/, otherwise(clone).validate(str)];
                    case 4:
                        temp = _a.sent();
                        return [2 /*return*/, temp && temp.result
                                ? __assign({}, temp.result, { overrideWith: temp }) : true];
                }
            });
        }); });
        return this;
    };
    TypeBase.prototype.testToTestResult = function (result) {
        if (typeof result === 'boolean') {
            return { valid: result, error: '' };
        }
        return result;
    };
    return TypeBase;
}());
exports.default = TypeBase;
