"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
exports.messages = {
    'boolean.typeof': function (name) { return name + " must be a valid boolean"; },
    'boolean.true': function (name) { return name + " must be true"; },
    'boolean.false': function (name) { return name + " must be false"; },
};
/**
 * Boolean class
 */
var TypeBoolean = /** @class */ (function (_super) {
    __extends(TypeBoolean, _super);
    /**
     * Constructor
     */
    function TypeBoolean() {
        var _this = _super.call(this) || this;
        _this.name = 'boolean';
        _this.typeof();
        return _this;
    }
    /**
     * Try to cast value
     *
     * @param {mixed} value
     * @return {boolean|mixed}
     */
    TypeBoolean.prototype._cast = function (value) {
        if (typeof value === 'string') {
            if (value === 'true' || value === 'True') {
                return true;
            }
            else if (value === 'false' || value === 'False') {
                return false;
            }
        }
        return value;
    };
    /**
     * Test to validate the type of the value
     *
     * @return {this}
     */
    TypeBoolean.prototype.typeof = function () {
        this.test('typeof', function (str) {
            return typeof str === 'boolean';
        });
        return this;
    };
    /**
     * Force a boolean to equal true
     *
     * @return {this}
     */
    TypeBoolean.prototype.true = function () {
        this.test('true', function (str) {
            return str === true;
        });
        return this;
    };
    /**
     * Force a boolean to equal false
     *
     * @return {this}
     */
    TypeBoolean.prototype.false = function () {
        this.test('false', function (str) {
            return str === false;
        });
        return this;
    };
    return TypeBoolean;
}(base_1.default));
exports.TypeBoolean = TypeBoolean;
var def = {
    Class: TypeBoolean,
    messages: exports.messages,
};
exports.default = def;
