"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var arraydiff_1 = require("./utils/arraydiff");
var isPlainObject_1 = require("lodash/isPlainObject");
var base_1 = require("./base");
exports.messages = {
    'object.typeof': function (name) { return name + " must be a valid object"; },
    'object.in': function (name, args) {
        return name + " must only contains these keys [" + args.in + "]";
    },
    'object.not': function (name) { return name + " contains forbidden value"; },
    'object.schema': function (name) { return name + " has not a valid schema"; },
    'object.oneOf': function (name, args, result) {
        if (result.error === 'oneIsRequired') {
            return name + " must contain one of these keys [" + args.keys + "]";
        }
        if (result.keys) {
            return name + " can not contain these two keys [" + result.keys + "] at the same time";
        }
        return 'unknown error';
    },
    'object.allOf': function (name, args) {
        return name + " must contain either none or all of these keys [" + args.keys + "]";
    },
};
/**
 * Object class
 */
var TypeObject = /** @class */ (function (_super) {
    __extends(TypeObject, _super);
    /**
     * Constructor
     */
    function TypeObject() {
        var _this = _super.call(this) || this;
        _this.name = 'object';
        _this.typeof();
        return _this;
    }
    /**
     * Test to validate the type of the value
     *
     * @return {this}
     */
    TypeObject.prototype.typeof = function () {
        this.test('typeof', function (str) {
            return isPlainObject_1.default(str);
        });
        return this;
    };
    TypeObject.prototype.in = function () {
        var _this = this;
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        var only = array;
        var options = { oneErrorPerKey: false };
        // handle someone passing literal array instead of multiple args
        if (array.length > 0 && Array.isArray(array[0])) {
            if (isPlainObject_1.default(array[1])) {
                options = __assign({}, array[1]);
            }
            only = array[0];
        }
        this.test('in', function (str) {
            var diff = arraydiff_1.default(Object.keys(str), only);
            if (diff.length <= 0) {
                return true;
            }
            if (options.oneErrorPerKey) {
                return {
                    valid: false,
                    error: 'in',
                    errors: diff.map(function (label) {
                        return {
                            test: _this.createTestResult(_this.createTest({ type: 'forbidden' }), false),
                            label: label,
                        };
                    }),
                };
            }
            return false;
        }, { in: only });
        return this;
    };
    TypeObject.prototype.not = function () {
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        var only = array;
        // handle someone passing literal array instead of multiple args
        if (array.length === 1 && Array.isArray(array[0])) {
            only = array[0];
        }
        this.test('not', function (str) {
            var diff = arraydiff_1.default(only, Object.keys(str));
            return diff.length === only.length;
        }, { not: only });
        return this;
    };
    /**
     * Validate an object with a fully qualified schema
     *
     * @param  {Altheia} schema
     * @param  {boolean} options.returnErrors If true, deep errors while be returned too
     * @return {this}
     */
    TypeObject.prototype.schema = function (schema, _a) {
        var _this = this;
        var _b = (_a === void 0 ? {} : _a).returnErrors, returnErrors = _b === void 0 ? true : _b;
        if (typeof schema.isValidator === 'undefined') {
            throw new Error('schema should be an instance of altheia validator "Alt({ ... })"');
        }
        this.test('schema', function (obj) { return __awaiter(_this, void 0, void 0, function () {
            var clone, hasError;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        clone = schema.clone();
                        return [4 /*yield*/, clone.body(obj).validate()];
                    case 1:
                        hasError = _a.sent();
                        return [2 /*return*/, {
                                valid: hasError === false,
                                error: 'schema',
                                errors: hasError && returnErrors ? clone._errorsRaw : undefined,
                            }];
                }
            });
        }); }, { schema: schema });
        return this;
    };
    TypeObject.prototype.oneOf = function () {
        var _this = this;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        if (params.length <= 1) {
            throw new Error('oneOf expect at least 2 params');
        }
        var oneIsRequired = false;
        var keys = [];
        if (typeof params[0] === 'boolean') {
            oneIsRequired = params[0];
            keys = params.splice(1);
        }
        else {
            keys = params;
        }
        this.test('oneOf', function (obj) { return __awaiter(_this, void 0, void 0, function () {
            var presence;
            return __generator(this, function (_a) {
                presence = {
                    a: null,
                    b: null,
                };
                try {
                    Object.keys(obj).forEach(function (key) {
                        if (keys.includes(key)) {
                            if (!presence.a) {
                                presence.a = key;
                            }
                            else if (!presence.b) {
                                presence.b = key;
                                throw new Error('a and b can not be present at the same time');
                            }
                        }
                    });
                }
                catch (e) {
                    return [2 /*return*/, {
                            valid: false,
                            error: 'exclusion',
                            keys: Object.values(presence),
                        }];
                }
                if (oneIsRequired && !presence.a && !presence.b) {
                    return [2 /*return*/, { valid: false, error: 'oneIsRequired' }];
                }
                return [2 /*return*/, true];
            });
        }); }, { oneIsRequired: oneIsRequired, keys: keys });
        return this;
    };
    /**
     * Force all keys to be mutually required. If one is presents, all are required. Pass if none are present.
     *
     * @param  {...string} keys
     * @return {this}
     */
    TypeObject.prototype.allOf = function () {
        var _this = this;
        var keys = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            keys[_i] = arguments[_i];
        }
        this.test('allOf', function (obj) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, (Object.keys(obj).reduce(function (acc, k) {
                        if (keys.includes(k)) {
                            acc += 1;
                        }
                        return acc;
                    }, 0) === keys.length)];
            });
        }); }, { keys: keys });
        return this;
    };
    return TypeObject;
}(base_1.default));
exports.TypeObject = TypeObject;
var def = {
    Class: TypeObject,
    messages: exports.messages,
};
exports.default = def;
